;DEMO 4
;Coldet_Sphere to mesh collision.




;Include helper functions and needed globals
Include "coldet.bb"



Graphics3D 640,480,0,2


;activate some global variables
coldet_start()


cam=CreateCamera()
MoveEntity cam,0,3,-5
light=CreateLight()


;------------------------------
;this is the static mesh
ob1=CreateCone()
EntityColor ob1,255,0,0

;Make the coldet models and get their pointers !
;Careful ! Do not use by mistake blitz's pointers.
c_ob1 = coldet_make(ob1,0);0=static

;------------------------------


;------------------------------
;create a collsion sphere
sp=CreateSphere()
EntityColor sp,255,255,0
EntityAlpha sp,.75
EntityFX sp,16
;------------------------------


px#=0
py#=0

PointEntity cam,ob1


While Not KeyHit(1)

RenderWorld()


;move the ray
If KeyDown(200) py=py+.02:update_spos(sp,px,py)
If KeyDown(208) py=py-.02:update_spos(sp,px,py)
If KeyDown(203) px=px-.02:update_spos(sp,px,py)
If KeyDown(205) px=px+.02:update_spos(sp,px,py)






res=coldet_sphere_collision%(c_ob1,col_center1,1.0);if a collision occurs between sphere and model
	Text 10,10,res
	If res
	coldet_collision_point(c_ob1,0);get the collision point
	Text 10,20,"x: "+collision_point_x()
	Text 10,30,"y: "+collision_point_y()
	Text 10,40,"z: "+collision_point_z()
	Text 10,60,"tri1: "+coldet_colliding_tri(c_ob1,0);model1 colliding tri
	EndIf

		

Text 200,0,"[ Cursor keys move the sphere ]"
		
Flip

Wend




;FREE THE COLDET MODELS FROM MEMORY !
coldet_free_model(c_ob1)


;free global stuff
coldet_end()



End




Function update_spos(sp,px#,py#)
PositionEntity sp,px,py,0,1
PokeFloat col_center1,0,EntityX(sp,1)
PokeFloat col_center1,4,EntityY(sp,1)
PokeFloat col_center1,8,EntityZ(sp,1)
End Function