;DEMO 5
;UTILITY FUNCTION 1
;Infinite Ray to sphere collision.





;Include helper functions and needed globals
Include "coldet.bb"



Graphics3D 640,480,0,2


;activate some global variables
coldet_start()


cam=CreateCamera()
MoveEntity cam,0,3,-5
light=CreateLight()



;------------------------------
;create a "ray like triangle" near the camera's position
ray=CreateMesh()
rs=CreateSurface(ray)
v0=AddVertex(rs,-.03,0,-5)
v1=AddVertex(rs,0,0,+50)
v2=AddVertex(rs,.03,0,-5)
AddTriangle(rs,v0,v1,v2)
EntityColor ray,255,255,0
UpdateNormals ray
EntityFX ray,16


;Set the rays origin in the ray_origin bank
PokeFloat ray_origin,0,0
PokeFloat ray_origin,4,0
PokeFloat ray_origin,8,-5

;and the start direction
PokeFloat ray_direction,0,(0-0)
PokeFloat ray_direction,4,(0-0)
PokeFloat ray_direction,8,(50-(-5))

;------------------------------




;------------------------------
;Create a collsion sphere
ob1=CreateSphere()
EntityColor ob1,255,0,0

;enter the spheres position
PokeFloat col_center1,0,0
PokeFloat col_center1,4,0
PokeFloat col_center1,8,0


;------------------------------


;variables to control the ray
rx#=0
ry#=0




PointEntity cam,ob1



	
While Not KeyHit(1)

RenderWorld()


;move the ray
If KeyDown(200) ry=ry+.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(208) ry=ry-.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(203) rx=rx-.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(205) rx=rx+.2 update_ray(rs,v1,rx#,ry#)






res=SphereRayCollision(col_center1,1.0,ray_origin,ray_direction,col_point);if a collision occurs between ray and model
	Text 10,10,res
	

	
Text 200,0,"[ Cursor keys move the ray ]"
		
Flip

Wend




;free global stuff
coldet_end()



End




;quick and dirty function to update the ray and it's direction bank
Function update_ray(rs,v1,rx#,ry#)
VertexCoords rs,v1,rx,ry,50
PokeFloat ray_direction,0,(rx#-0)
PokeFloat ray_direction,4,(ry#-0)
PokeFloat ray_direction,8,(50-(-5))

End Function